.model small, c
.686
.stack
include dosctr.asm
.data
.code
;---------------------------------------------------------------

codealign 8
CtBits  proc uses bx dx arg

        mov     dx,arg
        xor     ax,ax
        mov     bx,ax

@@:     shr     dx,1
        adc     ax,bx
        and     dx,dx
        jne     @B

        ret

CtBits  endp

;---------------------------------------------------------------

codealign 8
CBits   PROC

        push    bx
        xor     ax,ax       ;XOR always clears the carry flag
        push    dx
        mov     bx,ax

CBits0: adc     ax,bx
        shr     dx,1        ;the zero flag is set if DX = 0
        jnz     CBits0      ;JNZ does not look at the carry flag

        pop     dx
        adc     ax,bx       ;don't forget the last carry bit
        pop     bx

        ret

CBits   ENDP

;---------------------------------------------------------------
.startup

    invoke sleep, 50

    REPEAT 8

      ctr_begin 100
      ctr_end
      print dword$(eax)," cycles, empty",13,10

      ctr_begin 100
        invoke CtBits, 123
      ctr_end
      print dword$(eax)," cycles, CtBits",13,10

      ctr_begin 100
        mov dx, 123
        call CBits
      ctr_end
      print dword$(eax)," cycles, CBits",13,10

    ENDM

    call waitkey

.exit
end

